<?php

/**
 * Instruções de Cobrança para o Banco Itaú.
 */

namespace Cnab;

class Instrucao
{
    const ITAU_2 = '02';// DEVOLVER APÓS 05 DIAS DO VENCIMENTO
    const ITAU_3 = '03';// DEVOLVER APÓS 30 DIAS DO VENCIMENTO
    const ITAU_5 = '05';// RECEBER CONFORME INSTRUÇÕES NO PRÓPRIO TÍTULO
    const ITAU_6 = '06';// DEVOLVER APÓS 10 DIAS DO VENCIMENTO
    const ITAU_7 = '07';// DEVOLVER APÓS 15 DIAS DO VENCIMENTO
    const ITAU_8 = '08';// DEVOLVER APÓS 20 DIAS DO VENCIMENTO
    const ITAU_9 = '9';// PROTESTAR
    const ITAU_10 = '10';// NÃO PROTESTAR (inibe protesto, quando houver instrução permanente na conta corrente)
    const ITAU_11 = '11';// DEVOLVER APÓS 25 DIAS DO VENCIMENTO
    const ITAU_12 = '12';// DEVOLVER APÓS 35 DIAS DO VENCIMENTO
    const ITAU_13 = '13';// DEVOLVER APÓS 40 DIAS DO VENCIMENTO
    const ITAU_14 = '14';// DEVOLVER APÓS 45 DIAS DO VENCIMENTO
    const ITAU_15 = '15';// DEVOLVER APÓS 50 DIAS DO VENCIMENTO
    const ITAU_16 = '16';// DEVOLVER APÓS 55 DIAS DO VENCIMENTO
    const ITAU_17 = '17';// DEVOLVER APÓS 60 DIAS DO VENCIMENTO
    const ITAU_18 = '18';// DEVOLVER APÓS 90 DIAS DO VENCIMENTO
    const ITAU_19 = '19';// NÃO RECEBER APÓS 05 DIAS DO VENCIMENTO
    const ITAU_20 = '20';// NÃO RECEBER APÓS 10 DIAS DO VENCIMENTO
    const ITAU_21 = '21';// NÃO RECEBER APÓS 15 DIAS DO VENCIMENTO
    const ITAU_22 = '22';// NÃO RECEBER APÓS 20 DIAS DO VENCIMENTO
    const ITAU_23 = '23';// NÃO RECEBER APÓS 25 DIAS DO VENCIMENTO
    const ITAU_24 = '24';// NÃO RECEBER APÓS 30 DIAS DO VENCIMENTO
    const ITAU_25 = '25';// NÃO RECEBER APÓS 35 DIAS DO VENCIMENTO
    const ITAU_26 = '26';// NÃO RECEBER APÓS 40 DIAS DO VENCIMENTO
    const ITAU_27 = '27';// NÃO RECEBER APÓS 40 DIAS DO VENCIMENTO
    const ITAU_28 = '28';// NÃO RECEBER APÓS 50 DIAS DO VENCIMENTO
    const ITAU_29 = '29';// NÃO RECEBER APÓS 55 DIAS DO VENCIMENTO
    const ITAU_30 = '30';// IMPORTÂNCIA DE DESCONTO POR DIA
    const ITAU_31 = '31';// NÃO RECEBER APÓS 60 DIAS DO VENCIMENTO
    const ITAU_32 = '32';// NÃO RECEBER APÓS 90 DIAS DO VENCIMENTO
    const ITAU_33 = '33';// CONCEDER ABATIMENTO REF. À PIS-PASEP/COFIN/CSSL, MESMO APÓS VENCIMENTO
    const ITAU_34 = '34';// PROTESTAR APÓS XX DIAS CORRIDOS DO VENCIMENTO
    const ITAU_35 = '35';// PROTESTAR APÓS XX DIAS ÚTEIS DO VENCIMENTO
    const ITAU_37 = '37';// RECEBER ATÉ O ÚLTIMO DIA DO MÊS DE VENCIMENTO
    const ITAU_38 = '38';// CONCEDER DESCONTO MESMO APÓS VENCIMENTO
    const ITAU_39 = '39';// NÃO RECEBER APÓS O VENCIMENTO
    const ITAU_40 = '40';// CONCEDER DESCONTO CONFORME NOTA DE CRÉDITO
    const ITAU_42 = '42';// PROTESTO PARA FINS FALIMENTARES
    const ITAU_43 = '43';// SUJEITO A PROTESTO SE NÃO FOR PAGO NO VENCIMENTO
    const ITAU_44 = '44';// IMPORTÂNCIA POR DIA DE ATRASO A PARTIR DE DDMMAA
    const ITAU_45 = '45';// TEM DIA DA GRAÇA
    const ITAU_46 = '46';// USO DO BANCO
    const ITAU_47 = '47';// DISPENSAR JUROS/COMISSÃO DE PERMANÊNCIA
    const ITAU_51 = '51';// RECEBER SOMENTE COM A PARCELA ANTERIOR QUITADA
    const ITAU_52 = '52';// EFETUAR O PAGAMENTO SOMENTE ATRAVÉS DESTE BOLETO E NA REDE BANCÁRIA
    const ITAU_53 = '53';// USO DO BANCO
    const ITAU_54 = '54';// APÓS VENCIMENTO PAGÁVEL SOMENTE NA EMPRESA
    const ITAU_56 = '56';// USO DO BANCO
    const ITAU_57 = '57';// SOMAR VALOR DO TÍTULO AO VALOR DO CAMPO MORA/MULTA CASO EXISTA
    const ITAU_58 = '58';// DEVOLVER APÓS 365 DIAS DE VENCIDO
    const ITAU_59 = '59';// COBRANÇA NEGOCIADA. PAGÁVEL SOMENTE POR ESTE BOLETO NA REDE BANCÁRIA
    const ITAU_61 = '61';// TÍTULO ENTREGUE EM PENHOR EM FAVOR DO BENEFICIÁRIO ACIMA
    const ITAU_62 = '62';// TÍTULO TRANSFERIDO A FAVOR DO BENEFICIÁRIO
    const ITAU_66 = '66';// ENTRADA EM NEGATIVAÇÃO EXPRESSA (IMPRIME: SUJEITO A NEGATIVAÇÃO APÓS O VENCIMENTO)
    const ITAU_67 = '67';// NÃO NEGATIVAR (INIBE A ENTRADA EM NEGATIVAÇÃO EXPRESSA)
    const ITAU_70 = '70';// USO DO BANCO
    const ITAU_71 = '71';// USO DO BANCO
    const ITAU_72 = '72';// USO DO BANCO
    const ITAU_73 = '73';// USO DO BANCO
    const ITAU_74 = '74';// USO DO BANCO
    const ITAU_75 = '75';// USO DO BANCO
    const ITAU_78 = '78';// VALOR DA IDA ENGLOBA MULTA DE 10% PRO RATA
    const ITAU_79 = '79';// COBRAR JUROS APÓS 15 DIAS DA EMISSÃO (para títulos com vencimento à vista)
    const ITAU_80 = '80';// PAGAMENTO EM CHEQUE: SOMENTE RECEBER COM CHEQUE DE EMISSÃO DO PAGADOR
    const ITAU_83 = '83';// OPERAÇÃO REF A VENDOR
    const ITAU_84 = '84';// APÓS VENCIMENTO CONSULTAR A AGÊNCIA BENEFICIÁRIO
    const ITAU_86 = '86';// ANTES DO VENCIMENTO OU APÓS 15 DIAS, PAGÁVEL SOMENTE EM NOSSA SEDE
    const ITAU_87 = '87';// USO DO BANCO
    const ITAU_88 = '88';// NÃO RECEBER ANTES DO VENCIMENTO
    const ITAU_89 = '89';// USO DO BANCO
    const ITAU_90 = '90';// NO VENCIMENTO PAGÁVEL EM QUALQUER AGÊNCIA BANCÁRIA
    const ITAU_91 = '91';// NÃO RECEBER APÓS XX DIAS DO VENCIMENTO
    const ITAU_92 = '92';// DEVOLVER APÓS XX DIAS DO VENCIMENTO
    const ITAU_93 = '93';// MENSAGENS NOS BOLETOS COM 30 POSIÇÕES
    const ITAU_94 = '94';// MENSAGENS NOS BOLETOS COM 40 POSIÇÕES
    const ITAU_95 = '95';// USO DO BANCO
    const ITAU_96 = '96';// USO DO BANCO
    const ITAU_97 = '97';// USO DO BANCO
    const ITAU_98 = '98';// DUPLICATA / FATURA No
}
